diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/test/test-data-rate.cc ns-3.44/src/network/test/test-data-rate.cc
--- ns-3.43/src/network/test/test-data-rate.cc	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/test/test-data-rate.cc	2025-03-09 16:55:49.675372100 -0700
@@ -10,14 +10,15 @@
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 #include "ns3/test.h"
+#include "ns3/tuple.h"
 
 using namespace ns3;
 
 /**
- * \ingroup network-test
- * \ingroup tests
+ * @ingroup network-test
+ * @ingroup tests
  *
- * \brief Test Data rate
+ * @brief Test Data rate
  *
  */
 class DataRateTestCase : public TestCase
@@ -25,23 +26,23 @@
   public:
     /**
      * Constructor
-     * \param name test name
+     * @param name test name
      */
     DataRateTestCase(std::string name);
     ~DataRateTestCase() override;
 
     /**
      * Checks if two time values are equal
-     * \param t1 first time to check
-     * \param t2 second time to check
-     * \param msg check output message
+     * @param t1 first time to check
+     * @param t2 second time to check
+     * @param msg check output message
      */
     void CheckTimesEqual(Time t1, Time t2, const std::string msg);
     /**
      * Checks if two data rates values are equal
-     * \param d1 first data rate to check
-     * \param d2 second data rate to check
-     * \param msg check output message
+     * @param d1 first data rate to check
+     * @param d2 second data rate to check
+     * @param msg check output message
      */
     void CheckDataRateEqual(DataRate d1, DataRate d2, const std::string msg);
 
@@ -73,10 +74,10 @@
 }
 
 /**
- * \ingroup network-test
- * \ingroup tests
+ * @ingroup network-test
+ * @ingroup tests
  *
- * \brief Test Data rate
+ * @brief Test Data rate
  *
  */
 class DataRateTestCase1 : public DataRateTestCase
@@ -87,9 +88,9 @@
     /**
      * Checks that a given number of bits, at a specified datarate, are
      * corresponding to a given time
-     * \param rate the DataRate
-     * \param nBits number of bits
-     * \param correctTime expected time
+     * @param rate the DataRate
+     * @param nBits number of bits
+     * @param correctTime expected time
      */
     void SingleTest(std::string rate, size_t nBits, Time correctTime);
 
@@ -122,31 +123,31 @@
     {
         Time::SetResolution(Time::FS);
     }
-    SingleTest("1GB/s", 512, Time(NanoSeconds(64)));
-    SingleTest("8Gb/s", 512, Time(NanoSeconds(64)));
-    SingleTest("1Gb/s", 512, Time(NanoSeconds(512)));
-    SingleTest("8GB/s", 512, Time(NanoSeconds(8)));
+    SingleTest("1GB/s", 512, NanoSeconds(64));
+    SingleTest("8Gb/s", 512, NanoSeconds(64));
+    SingleTest("1Gb/s", 512, NanoSeconds(512));
+    SingleTest("8GB/s", 512, NanoSeconds(8));
     size_t nBits;
     for (nBits = 0; nBits <= 512; nBits++)
     {
-        SingleTest("1Mb/s", nBits, Time(MicroSeconds(nBits)));
-        SingleTest("10Mb/s", nBits, Time(NanoSeconds(nBits * 100)));
-        SingleTest("100Mb/s", nBits, Time(NanoSeconds(nBits * 10)));
-        SingleTest("1Gb/s", nBits, Time(NanoSeconds(nBits)));
-        SingleTest("10Gb/s", nBits, Time(PicoSeconds(nBits * 100)));
-        SingleTest("25Gb/s", nBits, Time(PicoSeconds(nBits * 40)));
-        SingleTest("40Gb/s", nBits, Time(PicoSeconds(nBits * 25)));
-        SingleTest("100Gb/s", nBits, Time(PicoSeconds(nBits * 10)));
-        SingleTest("200Gb/s", nBits, Time(PicoSeconds(nBits * 5)));
-        SingleTest("400Gb/s", nBits, Time(FemtoSeconds(nBits * 2500)));
+        SingleTest("1Mb/s", nBits, MicroSeconds(nBits));
+        SingleTest("10Mb/s", nBits, NanoSeconds(nBits * 100));
+        SingleTest("100Mb/s", nBits, NanoSeconds(nBits * 10));
+        SingleTest("1Gb/s", nBits, NanoSeconds(nBits));
+        SingleTest("10Gb/s", nBits, PicoSeconds(nBits * 100));
+        SingleTest("25Gb/s", nBits, PicoSeconds(nBits * 40));
+        SingleTest("40Gb/s", nBits, PicoSeconds(nBits * 25));
+        SingleTest("100Gb/s", nBits, PicoSeconds(nBits * 10));
+        SingleTest("200Gb/s", nBits, PicoSeconds(nBits * 5));
+        SingleTest("400Gb/s", nBits, FemtoSeconds(nBits * 2500));
     }
 }
 
 /**
- * \ingroup network-test
- * \ingroup tests
+ * @ingroup network-test
+ * @ingroup tests
  *
- * \brief Test Data rate
+ * @brief Test Data rate
  *
  */
 class DataRateTestCase2 : public DataRateTestCase
@@ -155,30 +156,30 @@
     DataRateTestCase2();
     /**
      * Checks data rate addition
-     * \param rate1 first data rate
-     * \param rate2 second data rate
-     * \param rate3 third data rate (first plus second)
+     * @param rate1 first data rate
+     * @param rate2 second data rate
+     * @param rate3 third data rate (first plus second)
      */
     void AdditionTest(std::string rate1, std::string rate2, std::string rate3);
     /**
      * Checks data rate subtraction
-     * \param rate1 first data rate
-     * \param rate2 second data rate
-     * \param rate3 third data rate (first minus second)
+     * @param rate1 first data rate
+     * @param rate2 second data rate
+     * @param rate3 third data rate (first minus second)
      */
     void SubtractionTest(std::string rate1, std::string rate2, std::string rate3);
     /**
      * Checks data rate integer multiplication
-     * \param rate1 first data rate
-     * \param factor multiplication factor
-     * \param rate2 second data rate  (first multiplied by factor)
+     * @param rate1 first data rate
+     * @param factor multiplication factor
+     * @param rate2 second data rate  (first multiplied by factor)
      */
     void MultiplicationIntTest(std::string rate1, uint64_t factor, std::string rate2);
     /**
      * Checks data rate floating point multiplication
-     * \param rate1 first data rate
-     * \param factor multiplication factor
-     * \param rate2 second data rate  (first multiplied by factor)
+     * @param rate1 first data rate
+     * @param factor multiplication factor
+     * @param rate2 second data rate  (first multiplied by factor)
      */
     void MultiplicationDoubleTest(std::string rate1, double factor, std::string rate2);
 
@@ -259,10 +260,90 @@
 }
 
 /**
- * \ingroup network-test
- * \ingroup tests
+ * @ingroup network-test
+ * @ingroup tests
  *
- * \brief DataRate TestSuite
+ * Object with an attribute that is a tuple of data rates and a string.
+ */
+class DataRateTupleObject : public Object
+{
+  public:
+    ~DataRateTupleObject() override = default;
+
+    /**
+     * @brief Get the type ID.
+     * @return The object TypeId.
+     */
+    static TypeId GetTypeId();
+
+    std::tuple<DataRate, DataRate, std::string> m_tupleRatesString; //!< tuple of two data rates
+                                                                    //!< and a string
+};
+
+TypeId
+DataRateTupleObject::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::DataRateTupleObject")
+            .SetParent<Object>()
+            .SetGroupName("Test")
+            .AddConstructor<DataRateTupleObject>()
+            .AddAttribute(
+                "TupleRatesString",
+                "An example of tuple of two data rates (comprising value and unit, possibly "
+                "separated by a white space) and a string (possibly containing a white space).",
+                StringValue("{1 Mb/s, 10kb/s, test string}"),
+                MakeTupleAccessor<DataRateValue, DataRateValue, StringValue>(
+                    &DataRateTupleObject::m_tupleRatesString),
+                MakeTupleChecker<DataRateValue, DataRateValue, StringValue>(MakeDataRateChecker(),
+                                                                            MakeDataRateChecker(),
+                                                                            MakeStringChecker()));
+    return tid;
+}
+
+/**
+ * @ingroup network-test
+ * @ingroup tests
+ *
+ * Attribute set and get TestCase.
+ */
+class DataRateTupleSetGetTestCase : public TestCase
+{
+  public:
+    DataRateTupleSetGetTestCase();
+    ~DataRateTupleSetGetTestCase() override = default;
+
+  private:
+    void DoRun() override;
+};
+
+DataRateTupleSetGetTestCase::DataRateTupleSetGetTestCase()
+    : TestCase("test attribute set and get")
+{
+}
+
+void
+DataRateTupleSetGetTestCase::DoRun()
+{
+    Ptr<DataRateTupleObject> obj = CreateObject<DataRateTupleObject>();
+
+    // check that the tuple of two data rates and a string was correctly initialized
+    NS_TEST_EXPECT_MSG_EQ(std::get<0>(obj->m_tupleRatesString),
+                          DataRate(1e6),
+                          "Unexpected value for the first data rate");
+    NS_TEST_EXPECT_MSG_EQ(std::get<1>(obj->m_tupleRatesString),
+                          DataRate(1e4),
+                          "Unexpected value for the second data rate");
+    NS_TEST_EXPECT_MSG_EQ(std::get<2>(obj->m_tupleRatesString),
+                          "test string",
+                          "Unexpected value for the string");
+}
+
+/**
+ * @ingroup network-test
+ * @ingroup tests
+ *
+ * @brief DataRate TestSuite
  */
 class DataRateTestSuite : public TestSuite
 {
@@ -275,6 +356,7 @@
 {
     AddTestCase(new DataRateTestCase1(), TestCase::Duration::QUICK);
     AddTestCase(new DataRateTestCase2(), TestCase::Duration::QUICK);
+    AddTestCase(new DataRateTupleSetGetTestCase(), TestCase::Duration::QUICK);
 }
 
 static DataRateTestSuite sDataRateTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/address-utils.cc ns-3.44/src/network/utils/address-utils.cc
--- ns-3.43/src/network/utils/address-utils.cc	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/address-utils.cc	2025-03-09 16:55:49.675372100 -0700
@@ -156,6 +156,28 @@
     return false;
 }
 
+Address
+ConvertToSocketAddress(const Address& address, uint16_t port)
+{
+    NS_LOG_FUNCTION(address << port);
+    Address convertedAddress;
+    if (Ipv4Address::IsMatchingType(address))
+    {
+        convertedAddress = InetSocketAddress(Ipv4Address::ConvertFrom(address), port);
+        NS_LOG_DEBUG("Address converted to " << convertedAddress);
+    }
+    else if (Ipv6Address::IsMatchingType(address))
+    {
+        convertedAddress = Inet6SocketAddress(Ipv6Address::ConvertFrom(address), port);
+        NS_LOG_DEBUG("Address converted to " << convertedAddress);
+    }
+    else
+    {
+        NS_FATAL_ERROR("This function should be called for an IPv4 or an IPv6 address");
+    }
+    return convertedAddress;
+}
+
 } // namespace addressUtils
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/address-utils.h ns-3.44/src/network/utils/address-utils.h
--- ns-3.43/src/network/utils/address-utils.h	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/address-utils.h	2025-03-09 16:55:49.675372100 -0700
@@ -21,87 +21,87 @@
 {
 
 /**
- * \brief Write an Ipv4Address to a Buffer
- * \param i a reference to the buffer to write to
- * \param ad the Ipv4Address
+ * @brief Write an Ipv4Address to a Buffer
+ * @param i a reference to the buffer to write to
+ * @param ad the Ipv4Address
  */
 void WriteTo(Buffer::Iterator& i, Ipv4Address ad);
 
 /**
- * \brief Write an Ipv4Address to a Buffer
- * \param i a reference to the buffer to write to
- * \param ad the Ipv6Address
+ * @brief Write an Ipv4Address to a Buffer
+ * @param i a reference to the buffer to write to
+ * @param ad the Ipv6Address
  */
 void WriteTo(Buffer::Iterator& i, Ipv6Address ad);
 
 /**
- * \brief Write an Address to a Buffer
- * \param i a reference to the buffer to write to
- * \param ad the Address
+ * @brief Write an Address to a Buffer
+ * @param i a reference to the buffer to write to
+ * @param ad the Address
  */
 void WriteTo(Buffer::Iterator& i, const Address& ad);
 
 /**
- * \brief Write an Mac64Address to a Buffer
- * \param i a reference to the buffer to write to
- * \param ad the Mac64Address
+ * @brief Write an Mac64Address to a Buffer
+ * @param i a reference to the buffer to write to
+ * @param ad the Mac64Address
  */
 void WriteTo(Buffer::Iterator& i, Mac64Address ad);
 
 /**
- * \brief Write an Mac48Address to a Buffer
- * \param i a reference to the buffer to write to
- * \param ad the Mac48Address
+ * @brief Write an Mac48Address to a Buffer
+ * @param i a reference to the buffer to write to
+ * @param ad the Mac48Address
  */
 void WriteTo(Buffer::Iterator& i, Mac48Address ad);
 
 /**
- * \brief Write an Mac16Address to a Buffer
- * \param i a reference to the buffer to write to
- * \param ad the Mac16Address
+ * @brief Write an Mac16Address to a Buffer
+ * @param i a reference to the buffer to write to
+ * @param ad the Mac16Address
  */
 void WriteTo(Buffer::Iterator& i, Mac16Address ad);
 
 /**
- * \brief Read an Ipv4Address from a Buffer
- * \param i a reference to the buffer to read from
- * \param ad a reference to the Ipv4Address to be read
+ * @brief Read an Ipv4Address from a Buffer
+ * @param i a reference to the buffer to read from
+ * @param ad a reference to the Ipv4Address to be read
  */
 void ReadFrom(Buffer::Iterator& i, Ipv4Address& ad);
 
 /**
- * \brief Read an Ipv6Address from a Buffer
- * \param i a reference to the buffer to read from
- * \param ad a reference to the Ipv6Address to be read
+ * @brief Read an Ipv6Address from a Buffer
+ * @param i a reference to the buffer to read from
+ * @param ad a reference to the Ipv6Address to be read
  */
 void ReadFrom(Buffer::Iterator& i, Ipv6Address& ad);
 
 /**
- * \brief Read an Address from a Buffer
- * \param i a reference to the buffer to read from
- * \param ad a reference to the Address to be read
- * \param len the length of the Address
+ * @brief Read an Address from a Buffer
+ * @param i a reference to the buffer to read from
+ * @param ad a reference to the Address to be read
+ * @param len the length of the Address
  */
 void ReadFrom(Buffer::Iterator& i, Address& ad, uint32_t len);
 
 /**
- * \brief Read a Mac64Address from a Buffer
- * \param i a reference to the buffer to read from
- * \param ad a reference to the Mac64Address to be read
+ * @brief Read a Mac64Address from a Buffer
+ * @param i a reference to the buffer to read from
+ * @param ad a reference to the Mac64Address to be read
  */
 void ReadFrom(Buffer::Iterator& i, Mac64Address& ad);
 
 /**
- * \brief Read a Mac48Address from a Buffer
- * \param i a reference to the buffer to read from
- * \param ad a reference to the Mac48Address to be read
+ * @brief Read a Mac48Address from a Buffer
+ * @param i a reference to the buffer to read from
+ * @param ad a reference to the Mac48Address to be read
  */
 void ReadFrom(Buffer::Iterator& i, Mac48Address& ad);
 
 /**
- * \brief Read a Mac16Address from a Buffer
- * \param i a reference to the buffer to read from
- * \param ad a reference to the Mac16Address to be read
+ * @brief Read a Mac16Address from a Buffer
+ * @param i a reference to the buffer to read from
+ * @param ad a reference to the Mac16Address to be read
  */
 void ReadFrom(Buffer::Iterator& i, Mac16Address& ad);
 
@@ -109,9 +109,20 @@
 {
 
 /**
- * \brief Address family-independent test for a multicast address
+ * @brief Address family-independent test for a multicast address
+ * @param ad the address to test
+ * @return true if the address is a multicast address, false otherwise
  */
 bool IsMulticast(const Address& ad);
+
+/**
+ * @brief Convert IPv4/IPv6 address with port to a socket address
+ * @param address the address to convert
+ * @param port the port
+ * @return the corresponding socket address
+ */
+Address ConvertToSocketAddress(const Address& address, uint16_t port);
+
 }; // namespace addressUtils
 
 }; // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/bit-deserializer.h ns-3.44/src/network/utils/bit-deserializer.h
--- ns-3.43/src/network/utils/bit-deserializer.h	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/bit-deserializer.h	2025-03-09 16:55:49.675372100 -0700
@@ -17,9 +17,9 @@
 {
 
 /**
- * \ingroup packet
+ * @ingroup packet
  *
- * \brief Bit deserializer. See also \sa ns3::BitSerializer
+ * @brief Bit deserializer. See also \sa ns3::BitSerializer
  *
  * This class helps converting a variable number, variable sized
  * number of bit-boundary fields stored as byte array representation
@@ -36,20 +36,20 @@
 
     /**
      * Pushes some bytes into the blob to be deserialized.
-     * \param bytes The bytes to add.
+     * @param bytes The bytes to add.
      */
     void PushBytes(std::vector<uint8_t> bytes);
 
     /**
      * Pushes some bytes into the blob to be deserialized.
-     * \param bytes The bytes to add.
-     * \param size The length of the array.
+     * @param bytes The bytes to add.
+     * @param size The length of the array.
      */
     void PushBytes(uint8_t* bytes, uint32_t size);
 
     /**
      * Pushes one byte into the blob to be deserialized.
-     * \param byte The byte to add.
+     * @param byte The byte to add.
      */
     void PushByte(uint8_t byte);
 
@@ -60,8 +60,8 @@
      *
      * The maximum number of bits to be deserialized in one single call is 64.
      *
-     * \param size The number of bits to pop.
-     * \return The popped bits value
+     * @param size The number of bits to pop.
+     * @return The popped bits value
      */
     uint64_t GetBits(uint8_t size);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/bit-serializer.h ns-3.44/src/network/utils/bit-serializer.h
--- ns-3.43/src/network/utils/bit-serializer.h	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/bit-serializer.h	2025-03-09 16:55:49.675372100 -0700
@@ -16,15 +16,15 @@
 {
 
 /**
- * \ingroup packet
+ * @ingroup packet
  *
- * \brief Bit serializer. See also \sa ns3::BitDeserializer
+ * @brief Bit serializer. See also \sa ns3::BitDeserializer
  *
  * This class helps converting a variable number, variable sized
  * number of bit-boundary fields to its final byte array representation.
  *
  * The typical use-case is:
- * \verbatim
+ * @verbatim
    aaa: A field
    bbb: B field
    ccc: C field
@@ -52,14 +52,14 @@
 
     /**
      * Toggles the padding insertion policy.
-     * \param padAtEnd true if the padding have to be inserted at the end of the bit blob.
+     * @param padAtEnd true if the padding have to be inserted at the end of the bit blob.
      */
     void InsertPaddingAtEnd(bool padAtEnd);
 
     /**
      * Pushes a number of bits in the blob.
-     * \param value the bits to be inserted.
-     * \param significantBits Number of bits to insert.
+     * @param value the bits to be inserted.
+     * @param significantBits Number of bits to insert.
      */
     void PushBits(uint64_t value, uint8_t significantBits);
 
@@ -68,9 +68,9 @@
      * Note that this operation  \b automatically add the
      * needed padding at the end (or start) of the blob.
      *
-     * \warning {This operation clears the stored data.}
+     * @warning {This operation clears the stored data.}
      *
-     * \returns The byte representation of the blob.
+     * @returns The byte representation of the blob.
      */
     std::vector<uint8_t> GetBytes();
 
@@ -79,11 +79,11 @@
      * Note that this operation  \b automatically add the
      * needed padding at the end (or start) of the blob.
      *
-     * \warning {This operation clears the stored data.}
+     * @warning {This operation clears the stored data.}
      *
-     * \param [out] buffer The buffer where to store the return data.
-     * \param [in] size The size of the buffer.
-     * \returns The number of bytes actually used in the buffer.
+     * @param [out] buffer The buffer where to store the return data.
+     * @param [in] size The size of the buffer.
+     * @returns The number of bytes actually used in the buffer.
      */
     uint8_t GetBytes(uint8_t* buffer, uint32_t size);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/crc32.h ns-3.44/src/network/utils/crc32.h
--- ns-3.43/src/network/utils/crc32.h	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/crc32.h	2025-03-09 16:55:49.675372100 -0700
@@ -15,9 +15,9 @@
 /**
  * Calculates the CRC-32 for a given input
  *
- * \param data buffer to calculate the checksum for
- * \param length the length of the buffer (bytes)
- * \returns the computed crc-32.
+ * @param data buffer to calculate the checksum for
+ * @param length the length of the buffer (bytes)
+ * @returns the computed crc-32.
  *
  */
 uint32_t CRC32Calculate(const uint8_t* data, int length);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/data-rate.cc ns-3.44/src/network/utils/data-rate.cc
--- ns-3.43/src/network/utils/data-rate.cc	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/data-rate.cc	2025-03-09 16:55:49.675372100 -0700
@@ -24,7 +24,7 @@
 DataRate::DoParse(const std::string s, uint64_t* v)
 {
     NS_LOG_FUNCTION(s << v);
-    std::string::size_type n = s.find_first_not_of("0123456789.");
+    std::string::size_type n = s.find_first_not_of("0123456789. ");
     if (n != std::string::npos)
     { // Found non-numeric
         std::istringstream iss;
@@ -260,7 +260,7 @@
 operator>>(std::istream& is, DataRate& rate)
 {
     std::string value;
-    is >> value;
+    std::getline(is, value);
     uint64_t v;
     bool ok = DataRate::DoParse(value, &v);
     if (!ok)
